#!/usr/bin/env bash

set -x

### add thermal_conductivity property
sub_path=//OpenGeoSysProject/media/medium/properties
xmlstarlet ed --subnode $sub_path --type elem -n "property_thermal_conductivity" $1 > /tmp/t_property.prj
# add property name
xmlstarlet ed --subnode $sub_path/property_thermal_conductivity --type elem -n name -v thermal_conductivity /tmp/t_property.prj > /tmp/t_name.prj
# add property type
xmlstarlet ed --subnode $sub_path/property_thermal_conductivity --type elem -n type -v EffectiveThermalConductivityPorosityMixing /tmp/t_name.prj > /tmp/t_type.prj
# rename property_thermal_conductivity to property
xmlstarlet ed --rename "//OpenGeoSysProject/media/medium/properties/property_thermal_conductivity" -v "property" /tmp/t_type.prj > /tmp/with_thermal_conductivity.prj
#format the result file
xmlstarlet fo -s 4 /tmp/with_thermal_conductivity.prj > ${1}
